*** chan_sip.c.orig.2	Thu Aug  9 10:50:31 2007
--- chan_sip.c	Thu Aug  9 10:55:28 2007
***************
*** 1872,1877 ****
--- 1872,1890 ----
  	return;
  }
  
+ static void sip_destroy_history(struct sip_pvt* p) {
+ 	if (!p)
+ 		return;
+ 	if (p->history) {
+ 		struct sip_history *hist;
+ 		while( (hist = AST_LIST_REMOVE_HEAD(p->history, list)) )
+ 			free(hist);
+ 		free(p->history);
+ 		p->history = NULL;
+ 	}
+ 	return;
+ }
+ 
  /*! \brief Retransmit SIP message if no answer (Called from scheduler) */
  static int retrans_pkt(void *data)
  {
***************
*** 3056,3068 ****
  			ast_channel_unlock(p->owner);
  	}
  	/* Clear history */
! 	if (p->history) {
! 		struct sip_history *hist;
! 		while( (hist = AST_LIST_REMOVE_HEAD(p->history, list)) )
! 			free(hist);
! 		free(p->history);
! 		p->history = NULL;
! 	}
  
  	for (prev = NULL, cur = iflist; cur; prev = cur, cur = cur->next) {
  		if (cur == p) {
--- 3069,3075 ----
  			ast_channel_unlock(p->owner);
  	}
  	/* Clear history */
! 	sip_destroy_history(p);
  
  	for (prev = NULL, cur = iflist; cur; prev = cur, cur = cur->next) {
  		if (cur == p) {
***************
*** 14725,14732 ****
  			else
  				ast_log(LOG_DEBUG, "Adding subscription for extension %s context %s for peer %s\n", p->exten, p->context, p->username);
  		}
! 		if (p->autokillid > -1)
  			sip_cancel_destroy(p);	/* Remove subscription expiry for renewals */
  		if (p->expiry > 0)
  			sip_scheddestroy(p, (p->expiry + 10) * 1000);	/* Set timer for destruction of call at expiration */
  
--- 14732,14747 ----
  			else
  				ast_log(LOG_DEBUG, "Adding subscription for extension %s context %s for peer %s\n", p->exten, p->context, p->username);
  		}
! 
! 		if (p->autokillid > -1) {
  			sip_cancel_destroy(p);	/* Remove subscription expiry for renewals */
+ 
+ 			/* XXX this is the wrong place to do this but there
+ 			 * isn't an obvious way to do this somewhere else */
+ 			if (dumphistory)
+ 				sip_dump_history(p);
+ 			sip_destroy_history(p);
+ 		}
  		if (p->expiry > 0)
  			sip_scheddestroy(p, (p->expiry + 10) * 1000);	/* Set timer for destruction of call at expiration */
  
